'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _yylibUi = require('yylib-ui');

var _ItemHeader = require('./ItemHeader');

var _ItemHeader2 = _interopRequireDefault(_ItemHeader);

var _ItemContent = require('./ItemContent');

var _ItemContent2 = _interopRequireDefault(_ItemContent);

var _ItemFooter = require('./ItemFooter');

var _ItemFooter2 = _interopRequireDefault(_ItemFooter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var field = _yylibUi.YYClass.field,
    PropTypes = _yylibUi.YYClass.PropTypes;


var uiMeta = {
    name: 'ijz-listitem',
    fields: [
    //field 参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('prefixCls', 'ijz-listitem', PropTypes.string, false, '样式名前缀'), field('className', '', PropTypes.string, false, '样式'), field('dataItem', null, PropTypes.object, false, '行数据集'),
    //Header
    field('renderItemHeaderLeft', null, PropTypes.func, false, '头部左侧区域自定义渲染'), field('renderItemHeaderRight', null, PropTypes.func, false, '头部右侧区域自定义渲染'), field('itemHeaderLeftDataSet', [], PropTypes.array, false, '头部左侧区域左侧数据集，[{label: ***，dataIndex: ***，layout：***，type：***}]'), field('itemHeaderRightDataSet', [], PropTypes.array, false, '头部右侧区域右侧数据集，[{label: ***，dataIndex: ***，layout：***，type：***}]'),
    //Content
    field('renderItemContent', null, PropTypes.func, false, '中部区域自定义渲染'), field('itemContentCol', 2, PropTypes.number, true, '中间区域列数'), field('itemContentDataSet', null, PropTypes.array, false, '中间区域数据集，[{label: ***, dataIndex: ***}]'), field('itemContentRowGutter', 16, PropTypes.number, true, '中间区域栅格间隔'),
    //Footer
    field('renderItemFooterLeft', null, PropTypes.func, false, '脚部左侧区域自定义渲染'), field('renderItemFooterRight', null, PropTypes.func, false, '脚部右侧区域自定义渲染'), field('itemFooterLeftLabelDataSet', [], PropTypes.array, false, '脚部区域左侧标签数据集，[{key:***，label: ***}]'), field('itemFooterRightButtonDataSet', [], PropTypes.array, false, '脚部区域右侧按钮数据集，[{key:***，label: ***}]'), field('onItemFooterRightButtonClick', null, PropTypes.func, false, '脚部区域右侧按钮回调，(key，dataItem)=>{}'), field('customRenderDataSet', [], PropTypes.array, false, '键值项自定义渲染，[{dataIndex:{render:()=>{}}]')]
};

var IjzListItem = _yylibUi.YYClass.create({
    uiMeta: uiMeta,

    getInitialState: function getInitialState() {
        return {};
    },
    getClassName: function getClassName() {
        var prefixCls = this.props.prefixCls;

        return (0, _classnames2.default)(prefixCls);
    },
    render: function render() {
        var _props = this.props,
            uiRunMode = _props.uiRunMode,
            className = _props.className,
            children = _props.children,
            dataItem = _props.dataItem,
            renderItemHeaderLeft = _props.renderItemHeaderLeft,
            renderItemHeaderRight = _props.renderItemHeaderRight,
            itemHeaderLeftDataSet = _props.itemHeaderLeftDataSet,
            itemHeaderRightDataSet = _props.itemHeaderRightDataSet,
            renderItemContent = _props.renderItemContent,
            itemContentCol = _props.itemContentCol,
            itemContentDataSet = _props.itemContentDataSet,
            itemContentRowGutter = _props.itemContentRowGutter,
            renderItemFooter = _props.renderItemFooter,
            itemFooterLeftLabelDataSet = _props.itemFooterLeftLabelDataSet,
            itemFooterRightButtonDataSet = _props.itemFooterRightButtonDataSet,
            onItemFooterRightButtonClick = _props.onItemFooterRightButtonClick,
            customRenderDataSet = _props.customRenderDataSet,
            otherProps = _objectWithoutProperties(_props, ['uiRunMode', 'className', 'children', 'dataItem', 'renderItemHeaderLeft', 'renderItemHeaderRight', 'itemHeaderLeftDataSet', 'itemHeaderRightDataSet', 'renderItemContent', 'itemContentCol', 'itemContentDataSet', 'itemContentRowGutter', 'renderItemFooter', 'itemFooterLeftLabelDataSet', 'itemFooterRightButtonDataSet', 'onItemFooterRightButtonClick', 'customRenderDataSet']);

        return _react2.default.createElement(
            'div',
            _extends({}, otherProps, { className: (0, _classnames2.default)(this.getClassName(), className) }),
            _react2.default.createElement(_ItemHeader2.default, {
                dataItem: dataItem,
                rootPrefixCls: this.getClassName(),
                renderItemHeaderLeft: renderItemHeaderLeft,
                renderItemHeaderRight: renderItemHeaderRight,
                itemHeaderLeftDataSet: itemHeaderLeftDataSet,
                itemHeaderRightDataSet: itemHeaderRightDataSet,
                customRenderDataSet: customRenderDataSet
            }),
            _react2.default.createElement(_ItemContent2.default, {
                dataItem: dataItem,
                rootPrefixCls: this.getClassName(),
                renderItemContent: renderItemContent,
                itemContentCol: itemContentCol,
                itemContentDataSet: itemContentDataSet || children,
                itemContentRowGutter: itemContentRowGutter,
                customRenderDataSet: customRenderDataSet
            }),
            _react2.default.createElement(_ItemFooter2.default, {
                dataItem: dataItem,
                rootPrefixCls: this.getClassName(),
                renderItemFooter: renderItemFooter,
                itemFooterLeftLabelDataSet: itemFooterLeftLabelDataSet,
                itemFooterRightButtonDataSet: itemFooterRightButtonDataSet,
                onItemFooterRightButtonClick: onItemFooterRightButtonClick,
                customRenderDataSet: customRenderDataSet
            })
        );
    }
});

module.exports = IjzListItem;