"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var React = require('react');
var YYClass = require('../../base/YYClass');
var YYModal = require('../../modal/YYModal');
var YYForm = require('../form/YYForm');
var YYFormItem = require('../form/YYFormItem');
var YYInput = require('../input/YYInput');

var _require = require('./utils'),
    requestCreateData = _require.requestCreateData;

var PropTypes = YYClass.PropTypes;


function noop() {}

var EntryRefDataModal = React.createClass({
    displayName: 'EntryRefDataModal',

    propTypes: {
        onOk: PropTypes.func,
        onCancel: PropTypes.func,
        onSubmitSuccess: PropTypes.func,
        onSubmitFail: PropTypes.func,
        visible: PropTypes.bool
    },

    getDefaultProps: function getDefaultProps() {
        return {
            onOk: noop,
            onCancel: noop,
            onSubmitSuccess: noop,
            onSubmitFail: noop,
            visible: false
        };
    },

    getInitialState: function getInitialState() {
        var modalValue = '';

        return {
            modalValue: modalValue
        };
    },
    handleOk: function handleOk() {
        var _this = this;

        var props = this.props;
        props.form.validateFields(function (errors, values) {
            if (!!errors) {
                console.log('Errors in form!!!');
                return;
            }
            _this.requestCreateData(values);
        });
        this.state.modalValue = '';
        props.form.setFieldsValue({ name: '' });
        props.onOk();
    },
    handleCancel: function handleCancel(e) {
        var props = this.props;
        this.state.modalValue = '';
        props.form.setFieldsValue({ name: '' });
        props.onCancel(e);
    },


    /**
     * 参照接口方法
     */
    requestCreateData: requestCreateData,
    /**
     * 参照接口方法
     */

    render: function render() {
        var visible = this.props.visible;
        var getFieldProps = this.props.form.getFieldProps;


        return React.createElement(
            YYModal,
            { title: '\u6DFB\u52A0\u65B0\u7684\u9009\u9879',
                visible: visible,
                onOk: this.handleOk,
                onCancel: this.handleCancel },
            React.createElement(
                YYForm,
                { horizontal: true },
                React.createElement(
                    YYFormItem,
                    { label: '\u540D\u79F0', labelCol: { span: 4 },
                        wrapperCol: { span: 18 } },
                    React.createElement(YYInput, _extends({}, getFieldProps("name", {
                        initialValue: ''
                    }), { type: 'text', autoComplete: 'off' }))
                )
            )
        );
    }
});

module.exports = YYForm.create()(EntryRefDataModal);