'use strict';

/**
 * Created by wuhao on 16/7/18.
 */

var React = require('react');
var YYClass = require('../base/YYClass');
var field = YYClass.field;
var PropTypes = YYClass.PropTypes;
var YYIcon = require('../icon/YYIcon');
var YYButton = require('../button/YYButton');
var _ = require('lodash');
require('./style/index.less');

var uiMeta = {
    name: 'transfer-operation',
    fields: [
    //field参数列表：字段属性名|属性默认值|属性类型|是否必填|属性描述
    field('visible', true, PropTypes.bool, false, '是否显示'), field('disabled', false, PropTypes.bool, false, '是否禁用')]
};

var YYTransferOperation = YYClass.create({
    uiMeta: uiMeta,
    _handleMove: function _handleMove() {
        var flag = this.props.flag;
        if (_.isFunction(this.props.onHandleMove)) {
            this.props.onHandleMove(flag);
        }
    },
    render: function render() {
        var cls = 'yyui-transfer-btn-lr ' + (this.props.className ? this.props.className : '');
        var _props = this.props,
            flag = _props.flag,
            disabled = _props.disabled;

        var iconTitle;
        if (flag == 'right') {
            iconTitle = React.createElement(
                'div',
                null,
                this.props.text,
                React.createElement(YYIcon, { type: flag })
            );
        } else {
            iconTitle = React.createElement(
                'div',
                null,
                React.createElement(YYIcon, { type: flag }),
                this.props.text
            );
        }
        return React.createElement(
            YYButton,
            { type: 'primary', size: 'small', disabled: disabled, className: cls, onClick: this._handleMove },
            iconTitle
        );
    }
});

module.exports = YYTransferOperation;